// JPEGDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Axes.h"
#include "JPEG.h"
#include "JPEGDlg.h"
#include "Export.h"
#include "Pen.h"
#include "Gradient.h"
#include "Panel.h"
#include "Series.h"
#include "Titles.h"
#include "TeeChartDefines.h"
#include "Walls.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CJPEGDlg, CDialog)
	//{{AFX_MSG_MAP(CJPEGDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_EDITOR, OnEditor)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SAVECHART, OnSaveChart)
	ON_BN_CLICKED(IDC_NEWCHART, OnNewChart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJPEGDlg dialog
CJPEGDlg::CJPEGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJPEGDlg::IDD, pParent),
	m_strFileName("C:\\MyChart.jpg"),
	m_bSpeed(false),
	m_bGray(false)
{
	//{{AFX_DATA_INIT(CJPEGDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CJPEGDlg::~CJPEGDlg()
{
	try
	{
		CFile::Remove(m_strFileName);
	}
	catch(...)
	{
	}
}

void CJPEGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJPEGDlg)
	DDX_Control(pDX, IDC_COPY, m_ctrlCopy);
	DDX_Control(pDX, IDC_SLIDER, m_ctrlSlider);
	DDX_Control(pDX, IDC_TCHART, m_ctrlChart);
	DDX_Check(pDX, IDC_SPEED, m_bSpeed);
	DDX_Check(pDX, IDC_GRAYSCALE, m_bGray);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CJPEGDlg message handlers
BOOL CJPEGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Custom initialization 
	m_ctrlSlider.SetRange(5, 100);
	m_ctrlSlider.SetPos(30);
	m_ctrlChart.GetPanel().GetGradient().SetStartColor(RGB(255, 255, 255));
	m_ctrlChart.GetPanel().GetGradient().SetEndColor(RGB(255, 255, 0));
	m_ctrlChart.GetPanel().GetGradient().SetVisible(true);
	m_ctrlChart.AddSeries(scLine);
	m_ctrlChart.GetSeries(0).FillSampleValues(200);

	GetDlgItem(IDC_FILELOADFROM)->SetWindowText("");

	char szFileName[MAX_PATH + 1];
	if (0 != ::GetTempPath(MAX_PATH, szFileName))
	{
		m_strFileName = szFileName;
		m_strFileName += "MyChart.jpg";
	}

	// As we are using BackImageLoad to load the saved JPEG
	// these objects are already there, so hide them here
	// If you have the Microsoft Image Contol available and would like
	// to just display the JPEG we suggest to use it instead of a 2nd
	// TeeChart
	m_ctrlCopy.GetWalls().SetVisible(false);
	m_ctrlCopy.GetAxis().SetVisible(false);
	m_ctrlCopy.GetHeader().SetVisible(false);
	m_ctrlCopy.GetFrame().SetVisible(false);

	// Don't want to see it until something is copied into it
	m_ctrlCopy.ShowWindow(SW_HIDE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJPEGDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
		m_ctrlChart.AboutBox();
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CJPEGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CJPEGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJPEGDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// it can only be our scrollbar, but may be we'll
	// add another one sometimes
	if (pScrollBar->m_hWnd == m_ctrlSlider.m_hWnd)
	{
		CString str;
		str.Format("%d%%", m_ctrlSlider.GetPos());
		GetDlgItem(IDC_QUALITY)->SetWindowText(str);
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CJPEGDlg::OnClose() 
{
	EndDialog(IDOK);	
}

void CJPEGDlg::OnEditor() 
{
	m_ctrlChart.ShowEditor();	
}

void CJPEGDlg::OnLoad() 
{
	m_ctrlCopy.GetPanel().BackImageLoad((const char *)m_strFileName);

	// Hide the placeholder for the chart
	GetDlgItem(IDC_RECT)->ShowWindow(SW_HIDE);
	m_ctrlCopy.ShowWindow(SW_SHOW);
}

void CJPEGDlg::OnSaveChart() 
{
	UpdateData(true);
	
	// The way EJPEGPerformance values are defined
	// m_bSpeed decides whether we save with jpegBestSpeed
	// or jpegBestQuality
	m_ctrlChart.GetExport().SaveToJPEGFile(m_strFileName,
                                  m_bGray,  m_bSpeed, 
                                  m_ctrlSlider.GetPos(),
                                  m_ctrlChart.GetWidth(),
                                  m_ctrlChart.GetHeight());
	CString str;
	// Don't forget the ampersand
	str.Format("&Load from %s", (const char*)m_strFileName);
	GetDlgItem(IDC_LOAD)->SetWindowText(str);
	GetDlgItem(IDC_LOAD)->EnableWindow(true);
	CFile file(m_strFileName, CFile::modeRead);
	str.Format("JPeg file size: %ld bytes", file.GetLength());
	GetDlgItem(IDC_FILELOADFROM)->SetWindowText(str);

}

void CJPEGDlg::OnNewChart() 
{
	m_ctrlChart.RemoveAllSeries();	
	m_ctrlChart.AddSeries(scLine);
	m_ctrlChart.GetSeries(0).FillSampleValues(200);

	CString str;
	// Don't forget the ampersand
	str.Format("&Load  JPEG File");
	GetDlgItem(IDC_LOAD)->SetWindowText(str);
	GetDlgItem(IDC_LOAD)->EnableWindow(false);
	GetDlgItem(IDC_FILELOADFROM)->SetWindowText("");
	GetDlgItem(IDC_RECT)->ShowWindow(SW_SHOW);
	m_ctrlCopy.ShowWindow(SW_HIDE);
}
