// ScrollingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Axes.h"
#include "Axis.h"
#include "Gradient.h"
#include "Legend.h"
#include "Panel.h"
#include "Series.h"
#include "TeeChartDefines.h"
#include "Scrolling.h"
#include "ScrollingDlg.h"
#include "ValueList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int nTimer = 1234;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScrollingDlg dialog
BEGIN_MESSAGE_MAP(CScrollingDlg, CDialog)
	//{{AFX_MSG_MAP(CScrollingDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADDPOINT, OnAddPoint)
	ON_BN_CLICKED(IDC_ANIMATE, OnAnimate)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CScrollingDlg::CScrollingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScrollingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScrollingDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScrollingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScrollingDlg)
	DDX_Control(pDX, IDC_TCHART, m_ctrlChart);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CScrollingDlg message handlers
BOOL CScrollingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Custom initialization
	InitializeChart();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScrollingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CScrollingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CScrollingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScrollingDlg::OnAddPoint() 
{
	// Add a random point 1 minute later
	COleVariant var(m_ctrlChart.GetSeries(0).GetXValues().GetMaximum());
	COleDateTimeSpan span(0, 0, 1, 0);
	COleDateTime time(var);
	time += span;
	m_ctrlChart.GetSeries(0).AddXY(time, rand(), "", 
					m_ctrlChart.GetSeries(0).GetCount() % 2 ? RGB(255, 255, 0) 
															: RGB(255, 0, 0));
	ScrollXAxis();
}

void CScrollingDlg::OnAnimate() 
{
	if (((CButton *)GetDlgItem(IDC_ANIMATE))->GetCheck())
		SetTimer(nTimer, 1, NULL);	
	else
		KillTimer(nTimer);	
}

void CScrollingDlg::OnClose() 
{
	EndDialog(IDOK);	
}

void CScrollingDlg::InitializeChart()
{
	m_ctrlChart.GetLegend().SetVisible(false);
	m_ctrlChart.RemoveAllSeries();
	m_ctrlChart.AddSeries(scLine);
	CSeries aSeries = m_ctrlChart.GetSeries(0);
	// add some arbitrary y values
	// Seed the random-number generator with current time
	srand((unsigned)time(NULL));

	COleDateTime time;
	time.GetCurrentTime();
	// let's add 60 minutes from current time noon
	COleDateTimeSpan span(0, 0, 1, 0);
	GetDlgItem(IDC_TIMEMIN)->SetWindowText(time.Format());
	for (int i = 0; i < 60; i++)
	{
		aSeries.AddXY(time, rand(), "", RGB(255, 0,0));
		time += span;
	}
    aSeries.GetXValues().SetDateTime(true);
	GetDlgItem(IDC_TIMEMAX)->SetWindowText(time.Format());
	m_ctrlChart.GetPanel().GetGradient().SetEndColor(RGB(255, 255, 255));
	m_ctrlChart.GetPanel().GetGradient().SetStartColor(RGB(0, 0, 255));
	m_ctrlChart.GetPanel().GetGradient().SetVisible(true);
}

void CScrollingDlg::ScrollXAxis()
{
	CAxis aAxis = m_ctrlChart.GetAxis().GetBottom();
	aAxis.SetAutomatic(false);
	COleVariant var(m_ctrlChart.GetSeries(0).GetXValues().GetMaximum());
	COleDateTimeSpan span(0, 0, 5, 0);
	COleDateTime time(var);
	time += span;
	GetDlgItem(IDC_TIMEMAX)->SetWindowText(time.Format());
	aAxis.SetMaximum(time);
	span.SetDateTimeSpan(0, 1, 0, 0);
	time -= span;
	aAxis.SetMinimum(time);
	GetDlgItem(IDC_TIMEMIN)->SetWindowText(time.Format());

}

void CScrollingDlg::OnTimer(UINT nIDEvent) 
{
	if(nTimer == nIDEvent)	
		OnAddPoint();
	else
		CDialog::OnTimer(nIDEvent);
}

