// SurfaceDlg.cpp : implementation file
//

#include "stdafx.h"
#include <Math.h>
#include "Aspect.h"
#include "ChartFont.h"
#include "Legend.h"
#include "Series.h"
#include "Strings.h"
#include "SurfaceDlg.h"
#include "SurfaceSeries.h"
#include "TeeChartDefines.h"
#include "Titles.h"
#include "Walls.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int nTimer = 1234;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CSurfaceDlg, CDialog)
	//{{AFX_MSG_MAP(CSurfaceDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_WIREFRAME, OnWireframe)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RANGE, OnRange)
	ON_BN_CLICKED(IDC_PALETTE, OnPalette)
	ON_BN_CLICKED(IDC_SOLID, OnSolid)
	ON_BN_CLICKED(IDC_EDITOR, OnEditor)
	ON_BN_CLICKED(IDC_ANIMATE, OnAnimate)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSurfaceDlg dialog
CSurfaceDlg::CSurfaceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSurfaceDlg::IDD, pParent),
	nDelta(1),
	lDelta3D(3),
	m_bAnimate(false)
{
	//{{AFX_DATA_INIT(CSurfaceDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSurfaceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSurfaceDlg)
	DDX_Control(pDX, IDC_TEXT, m_stSize);
	DDX_Control(pDX, IDC_ANIMATE, m_ctrlAnimate);
	DDX_Control(pDX, IDC_WIREFRAME, m_ctrlWireFrame);
	DDX_Control(pDX, IDC_SLIDER, m_ctrlSlider);
	DDX_Control(pDX, IDC_TCHART, m_ctrlChart);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CSurfaceDlg message handlers
BOOL CSurfaceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Custom initialization here
	m_ctrlChart.RemoveAllSeries();
	m_ctrlChart.AddSeries(scSurface);
	m_ctrlChart.GetAspect().SetView3D(true);
	m_ctrlChart.GetAspect().SetChart3DPercent(70);
	m_ctrlChart.GetLegend().SetVisible(false);
	m_ctrlSlider.SetRange(2, 20);
	m_ctrlSlider.SetPos(8);
	((CButton *)GetDlgItem(IDC_RANGE))->SetCheck(true);
	m_ctrlChart.GetHeader().GetFont().SetSize(13);
	COleVariant var(CString("TeeChart Pro"));
	m_ctrlChart.GetHeader().GetText().Clear();
	m_ctrlChart.GetHeader().GetText().Add(*(LPCVARIANT)var);
	var = CString("Surface Series Example");
	m_ctrlChart.GetHeader().GetText().Add(*(LPCVARIANT)var);
	m_ctrlChart.GetWalls().SetBackColor(RGB(0, 255, 255));
	FillSurface();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSurfaceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CSurfaceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSurfaceDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSurfaceDlg::OnClose() 
{
	EndDialog(IDOK);	
}

void CSurfaceDlg::FillSurface()
{
	CString strSlider;
	strSlider.Format("%d x %d", m_ctrlSlider.GetPos(), m_ctrlSlider.GetPos());
	m_stSize.SetWindowText(strSlider);

	// remove all surface points...
	m_ctrlChart.GetSeries(0).Clear();

	// This also makes a type check
	CSurfaceSeries aSeries = m_ctrlChart.GetSeries(0).GetAsSurface();

	// set initial surface size (rows x columns)
	aSeries.SetNumXValues(m_ctrlSlider.GetPos());
	aSeries.SetNumZValues(m_ctrlSlider.GetPos());
  
	// add surface points with a loop
	int nMaxPoints = aSeries.GetNumXValues();
	for(int x = 1; x <= nMaxPoints; x++)
	{
		for (int z = 1; z <= nMaxPoints; z++)
		{
			double d= nMaxPoints * 0.2;
			aSeries.AddXYZ(x, 0.5 * cos(x / d) 
					+ cos(z / d), z, "", clTeeColor);
		}
	}
}

void CSurfaceDlg::OnWireframe() 
{
	m_ctrlChart.GetSeries(0).GetAsSurface().SetWireFrame(m_ctrlWireFrame.GetCheck());
}

void CSurfaceDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// it can only be our scrollbar, but may be we'll
	// add another one sometimes
	if (pScrollBar->m_hWnd == m_ctrlSlider.m_hWnd)
		FillSurface();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CSurfaceDlg::OnRange() 
{
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUseColorRange(true);
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUsePalette(false);
}

void CSurfaceDlg::OnPalette() 
{
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUseColorRange(false);
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUsePalette(true);
}

void CSurfaceDlg::OnSolid() 
{
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUseColorRange(false);
	m_ctrlChart.GetSeries(0).GetAsSurface().SetUsePalette(false);
}

void CSurfaceDlg::OnEditor() 
{
	m_ctrlChart.ShowEditor();	
}

void CSurfaceDlg::OnAnimate() 
{
/*	Although it should work, it does not
	if (((CButton *)GetDlgItem(IDC_RANGE))->GetCheck())
		SetTimer(nTimer, 1, NULL);	
	else
		KillTimer(nTimer);	
*/	
	m_bAnimate = !m_bAnimate;
	if (m_bAnimate)
		SetTimer(nTimer, 1, NULL);	
	else
		KillTimer(nTimer);	
}

void CSurfaceDlg::OnTimer(UINT nIDEvent) 
{
	if(nTimer == nIDEvent)	
	{
		if (m_ctrlSlider.GetPos() == m_ctrlSlider.GetRangeMax()
				|| m_ctrlSlider.GetPos() == m_ctrlSlider.GetRangeMin())
			nDelta *= -1;
		m_ctrlSlider.SetPos(m_ctrlSlider.GetPos() + nDelta);
		FillSurface();
				
		long l3DPercentage = m_ctrlChart.GetAspect().GetChart3DPercent();
		if (l3DPercentage >= 95 || l3DPercentage <= 5)
			lDelta3D *= -1;
		m_ctrlChart.GetAspect().SetChart3DPercent(l3DPercentage + lDelta3D);

	}
	else
		CDialog::OnTimer(nIDEvent);
}
